/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.45 from the
 * contents of UUID.xs. Do not edit this file, edit UUID.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "UUID.xs"
#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#ifdef PERL__UUID__UUID_UUID_H
#include <uuid/uuid.h>
#elif PERL__UUID__UUID_H
#include <uuid.h>
#elif PERL__UUID__RPC_H
#include <rpc.h>
#include <rpcdce.h>
#endif

#ifdef __cplusplus
}
#endif


/*
#ifndef SvPV_nolen
# define SvPV_nolen(sv) SvPV(sv, na)
#endif
*/

/* 2 hex digits per byte + 4 separators + 1 trailing null */
#define UUID_BUF_SZ() (2 * PERL__UUID__STRUCT_SZ + 4 + 1)

#ifdef PERL__UUID__E2FS_INT
#define UUID_T uuid_t
#define UUID2SV(u) ((char*)u)
#define SV2UUID(s) ((unsigned char*)SvGROW(s, sizeof(uuid_t)+1))

#elif PERL__UUID__RPC_INT
#define UUID_T uuid_t
#define UUID2SV(u) ((char*)&u)
#define SV2UUID(s) ((uuid_t*)SvGROW(s, sizeof(uuid_t)+1))

#elif PERL__UUID__WIN_INT
#define UUID_T UUID
#define UUID2SV(u) ((char*)&u)
#define SV2UUID(s) ((UUID*)SvGROW(s, sizeof(UUID)+1))

#elif PERL__UUID__OSSP_INT
#define UUID_T uuid_t*
#define UUID2SV(u) ((char*)&u)
#define SV2UUID(s) ((uuid_t*)SvGROW(s, UUID_LEN_STR+1))

#endif

#define SV2STR(s)  (SvGROW(s, UUID_BUF_SZ()+1))


#ifdef PERL__UUID__OSSP_INT
void croak_ossp(uuid_rc_t st) {
    croak("%s", uuid_error(st));
}
#endif


void do_generate(SV *str) {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    uuid_generate( uuid );
#elif PERL__UUID__RPC_INT
    int32_t s;
    uuid_create(&uuid, &s);
#elif PERL__UUID__WIN_INT
    RPC_STATUS st;
    st = UuidCreate(&uuid);
#elif PERL__UUID__OSSP_INT
    char *s = NULL;
    size_t len = 0;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_make(uuid,UUID_MAKE_V1|UUID_MAKE_MC)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(uuid, UUID_FMT_BIN, &s, &len)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    sv_setpvn(str, s, len);
    return;
#endif
    sv_setpvn(str, UUID2SV(uuid), sizeof(UUID_T));
}


void do_generate_random(SV *str) {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    uuid_generate_random( uuid );
#elif PERL__UUID__RPC_INT
    int32_t s;
    uuid_create(&uuid, &s);
#elif PERL__UUID__WIN_INT
    UuidCreate(&uuid);
#elif PERL__UUID__OSSP_INT
    char *s = NULL;
    size_t len = 0;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_make(uuid,UUID_MAKE_V4)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(uuid, UUID_FMT_BIN, &s, &len)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    sv_setpvn(str, s, len);
    return;
#endif
    sv_setpvn(str, UUID2SV(uuid), sizeof(UUID_T));
}


void do_generate_time(SV *str) {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    uuid_generate_time( uuid );
#elif PERL__UUID__RPC_INT
    int32_t s;
    uuid_create(&uuid, &s);
#elif PERL__UUID__WIN_INT
    UuidCreateSequential(&uuid);
#elif PERL__UUID__OSSP_INT
    char *s = NULL;
    size_t len = 0;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_make(uuid,UUID_MAKE_V1)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(uuid, UUID_FMT_BIN, &s, &len)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    sv_setpvn(str, s, len);
    return;
    (void)st;
#endif
    sv_setpvn(str, UUID2SV(uuid), sizeof(UUID_T));
}


void do_unparse(SV *in, SV * out) {
#ifdef PERL__UUID__E2FS_INT
    char str[UUID_BUF_SZ()];
    uuid_unparse(SV2UUID(in), str);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
#elif PERL__UUID__RPC_INT
    char *str;
    int32_t s;
    uuid_to_string(SV2UUID(in), &str, &s); /* free str */
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
    free(str);
#elif PERL__UUID__WIN_INT
    RPC_CSTR str;
    RPC_STATUS st;
    st = UuidToString(SV2UUID(in), &str); /* free str */
    if( st != RPC_S_OK )
        croak("UuidToString error: %i", st);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
    RpcStringFree(&str);
#elif PERL__UUID__OSSP_INT
    UUID_T uuid;
    char *str = NULL;
    size_t len = UUID_LEN_STR;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_import(uuid, UUID_FMT_BIN, SV2UUID(in), UUID_LEN_BIN)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(uuid, UUID_FMT_STR, &str, &len)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    sv_setpvn(out, str, len-1);
    free(str);
    (void)st;
#endif
}


void do_unparse_lower(SV *in, SV * out) {
#ifdef PERL__UUID__E2FS_INT
    char *p, str[UUID_BUF_SZ()];
    /* uuid_unparse_lower(SV2UUID(in), str); */ /* not on SunOS */
    uuid_unparse(SV2UUID(in), str);
    for(p=str; *p; ++p) *p = tolower(*p);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
#elif PERL__UUID__RPC_INT
    char *p, *str;
    int32_t s;
    uuid_to_string(SV2UUID(in), &str, &s); /* free str */
    for(p=str; *p; ++p) *p = tolower(*p);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
    free(str);
#elif PERL__UUID__WIN_INT
    char *p;
    RPC_CSTR str;
    RPC_STATUS st;
    st = UuidToString(SV2UUID(in), &str); /* free str */
    if( st != RPC_S_OK )
        croak("UuidToString error: %i", st);
    for(p=str; *p; ++p) *p = tolower(*p);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
    RpcStringFree(&str);
#elif PERL__UUID__OSSP_INT
    UUID_T uuid;
    char *p;
    char *str = NULL;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_import(uuid, UUID_FMT_BIN, SV2UUID(in), UUID_BUF_SZ()-1)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(SV2UUID(in), UUID_FMT_STR, &str, NULL)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    for(p=str; *p; ++p) *p = tolower(*p);
    sv_setpv(out, str);
    free(str);
    (void)st;
#endif
}


void do_unparse_upper(SV *in, SV * out) {
#ifdef PERL__UUID__E2FS_INT
    char *p, str[UUID_BUF_SZ()];
    /* uuid_unparse_upper(SV2UUID(in), str); */ /* not on SunOS */
    uuid_unparse(SV2UUID(in), str);
    for(p=str; *p; ++p) *p = toupper(*p);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
#elif PERL__UUID__RPC_INT
    char *p, *str;
    int32_t s;
    uuid_to_string(SV2UUID(in), &str, &s); /* free str */
    for(p=str; *p; ++p) *p = toupper(*p);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
    free(str);
#elif PERL__UUID__WIN_INT
    char *p;
    RPC_CSTR str;
    RPC_STATUS st;
    st = UuidToString(SV2UUID(in), &str); /* free str */
    if( st != RPC_S_OK )
        croak("UuidToString error: %i", st);
    for(p=str; *p; ++p) *p = toupper(*p);
    sv_setpvn(out, str, UUID_BUF_SZ()-1);
    RpcStringFree(&str);
#elif PERL__UUID__OSSP_INT
    UUID_T uuid;
    char *p;
    char *str = NULL;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_import(uuid, UUID_FMT_BIN, SV2UUID(in), UUID_BUF_SZ()-1)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(SV2UUID(in), UUID_FMT_STR, &str, NULL)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    for(p=str; *p; ++p) *p = toupper(*p);
    sv_setpv(out, str);
    free(str);
    (void)st;
#endif
}


int do_parse(SV *in, SV *out) {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    int rc;
    rc = uuid_parse(SV2STR(in), uuid);
    if( !rc )
        sv_setpvn(out, UUID2SV(uuid), sizeof(UUID_T));
    return rc;
#elif PERL__UUID__RPC_INT
    int rc;
    uuid_from_string(SV2STR(in), &uuid, &rc);
    if( !rc )
        sv_setpvn(out, UUID2SV(uuid), sizeof(UUID_T));
    return rc == uuid_s_ok ? 0 : -1;
#elif PERL__UUID__WIN_INT
    RPC_STATUS rc;
    rc = UuidFromString(SV2STR(in), &uuid);
    if( rc == RPC_S_OK )
        sv_setpvn(out, UUID2SV(uuid), sizeof(UUID_T));
    return rc == RPC_S_OK ? 0 : -1;
#elif PERL__UUID__OSSP_INT
    char *str = NULL;
    if (uuid_create(&uuid) != UUID_RC_OK)
        return -1;
    if (uuid_import(uuid, UUID_FMT_STR, SV2STR(in), UUID_LEN_STR) != UUID_RC_OK) {
        uuid_destroy(uuid);
        return -1;
    }
    if (uuid_export(uuid, UUID_FMT_BIN, &str, NULL) != UUID_RC_OK) {
        uuid_destroy(uuid);
        return -1;
    }
    uuid_destroy(uuid);
    sv_setpvn(out, str, UUID_LEN_BIN);
    free(str);
    return 0;
#endif
}


void do_clear(SV *in) {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    uuid_clear(uuid);
#elif PERL__UUID__RPC_INT
    int32_t s;
    uuid_create_nil(&uuid,&s);
#elif PERL__UUID__WIN_INT
    UuidCreateNil(&uuid);
#elif PERL__UUID__OSSP_INT
    char *str = NULL;
    size_t len = UUID_LEN_BIN;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_load(uuid, "nil")) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(uuid, UUID_FMT_BIN, &str, &len)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    sv_setpvn(in, str, len);
    return;
#endif
    sv_setpvn(in, UUID2SV(uuid), sizeof(UUID_T));
}


int do_is_null(SV *in) {
#ifdef PERL__UUID__E2FS_INT
    if( SvCUR(in) != sizeof(uuid_t) )
        return 0;
    return uuid_is_null(SV2UUID(in));
#elif PERL__UUID__RPC_INT
    int32_t s;
    return uuid_is_nil(SV2UUID(in),&s);
#elif PERL__UUID__WIN_INT
    int rc;
    RPC_STATUS st;
    rc = UuidIsNil(SV2UUID(in), &st);
    return rc == TRUE ? 1 : 0;
#elif PERL__UUID__OSSP_INT
    UUID_T uuid;
    int i;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_import(uuid, UUID_FMT_BIN, SV2STR(in), UUID_BUF_SZ()-1)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_isnil(uuid, &i)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    return i ? 1 : 0;
#endif
}


int do_compare(SV *uu1, SV *uu2) {
#ifdef PERL__UUID__E2FS_INT
/*
    if( SvCUR(uu1) == sizeof(uuid_t) )
        if( SvCUR(uu2) == sizeof(uuid_t) )
            return uuid_compare(SV2UUID(uu1), SV2UUID(uu2));
*/
#elif PERL__UUID__RPC_INT
/*
    int32_t s;
    if( SvCUR(uu1) == sizeof(uuid_t) )
        if( SvCUR(uu2) == sizeof(uuid_t) )
            return uuid_compare(SV2UUID(uu1), SV2UUID(uu2), &s);
*/
#elif PERL__UUID__WIN_INT
#elif PERL__UUID__OSSP_INT
#endif
    return sv_cmp(uu1, uu2);
}


void do_copy(SV *dst, SV *src) {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    if( SvCUR(src) != sizeof(uuid_t) )
        uuid_clear(uuid);
    else
        uuid_copy(uuid, SV2UUID(src));
#elif PERL__UUID__RPC_INT
    int32_t s;
    if( SvCUR(src) != sizeof(uuid_t) )
        uuid_create_nil(&uuid, &s);
    else
        memcpy(&uuid, SV2UUID(src), sizeof(uuid_t));
        /* uuid_copy(uuid, SV2UUID(src), &s);  <-- duh, not on bsd */
#elif PERL__UUID__WIN_INT
    if( SvCUR(src) != sizeof(uuid_t) )
        UuidCreateNil(&uuid);
    else
        memcpy(&uuid, SV2UUID(src), sizeof(UUID));
#elif PERL__UUID__OSSP_INT
    size_t len = SvCUR(src);
    if ( len != UUID_LEN_BIN ) {
        char *str = NULL;
        len = 0;
        uuid_rc_t st;
        if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
        if ((st = uuid_export(uuid, UUID_FMT_BIN, &str, &len)) != UUID_RC_OK) croak_ossp(st);
        if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
        sv_setpvn(dst, str, len);
        free(str);
        return;
    }
    sv_copypv(dst, src);
    return;
#endif
    sv_setpvn(dst, UUID2SV(uuid), sizeof(UUID_T));
}


SV* do_uuid() {
    UUID_T uuid;
#ifdef PERL__UUID__E2FS_INT
    char str[UUID_BUF_SZ()];
    uuid_generate(uuid);
    uuid_unparse(uuid, str);
    return newSVpvn(str, UUID_BUF_SZ()-1);
#elif PERL__UUID__RPC_INT
    SV *sv;
    char *str;
    int32_t s;
    uuid_create(&uuid, &s);
    uuid_to_string(&uuid, &str, &s); /* free str */
    sv = newSVpvn(str, UUID_BUF_SZ()-1);
    free(str);
    return sv;
#elif PERL__UUID__WIN_INT
    SV *sv;
    RPC_STATUS st;
    RPC_CSTR str;
    UuidCreateSequential(&uuid);
    st = UuidToString(&uuid, &str); /* free str */
    if( st != RPC_S_OK )
        croak("UuidToString error: %i", st);
    sv = newSVpvn(str, UUID_BUF_SZ()-1);
    RpcStringFree(&str);
    return sv;
#elif PERL__UUID__OSSP_INT
    SV *rv;
    char *str = NULL;
    size_t len = UUID_LEN_STR;
    uuid_rc_t st;
    if ((st = uuid_create(&uuid)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_make(uuid, UUID_MAKE_V1|UUID_MAKE_MC)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_export(uuid, UUID_FMT_STR, &str, &len)) != UUID_RC_OK) croak_ossp(st);
    if ((st = uuid_destroy(uuid)) != UUID_RC_OK) croak_ossp(st);
    rv = newSVpvn(str, len-1);
    free(str);
    return rv;
#endif
}


void do_debug() {
    SV *bmsg, *smsg;
#ifdef PERL__UUID__UUID_UUID_H
    PerlIO_puts(PerlIO_stderr(), "# Header: uuid/uuid.h\n");
#elif PERL__UUID__UUID_H
    PerlIO_puts(PerlIO_stderr(), "# Header: uuid.h\n");
#elif PERL__UUID__RPC_H
    PerlIO_puts(PerlIO_stderr(), "# Header: rpc.h\n");
#endif

#ifdef PERL__UUID__E2FS_INT
    PerlIO_puts(PerlIO_stderr(), "# Interface: e2fs\n");
#elif PERL__UUID__RPC_INT
    PerlIO_puts(PerlIO_stderr(), "# Interface: rpc\n");
#elif PERL__UUID__WIN_INT
    PerlIO_puts(PerlIO_stderr(), "# Interface: win\n");
#elif PERL__UUID__OSSP_INT
    PerlIO_puts(PerlIO_stderr(), "# Interface: ossp\n");
#endif

    bmsg = mess("# Buffer size: %i\n", UUID_BUF_SZ());
    PerlIO_puts(PerlIO_stderr(), SvPVX(bmsg));
    smsg = mess("# Struct size: %i\n", PERL__UUID__STRUCT_SZ);
    PerlIO_puts(PerlIO_stderr(), SvPVX(smsg));
}



#line 487 "UUID.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 631 "UUID.c"

XS_EUPXS(XS_UUID_generate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_generate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
#line 485 "UUID.xs"
    do_generate(str); 
#line 644 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_generate_random); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_generate_random)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
#line 492 "UUID.xs"
    do_generate_random(str); 
#line 661 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_generate_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_generate_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
#line 499 "UUID.xs"
    do_generate_time(str); 
#line 678 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_unparse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_unparse)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "in, out");
    {
	SV *	in = ST(0)
;
	SV *	out = ST(1)
;
#line 507 "UUID.xs"
    do_unparse(in, out);
#line 697 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_unparse_lower); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_unparse_lower)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "in, out");
    {
	SV *	in = ST(0)
;
	SV *	out = ST(1)
;
#line 515 "UUID.xs"
    do_unparse_lower(in, out);
#line 716 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_unparse_upper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_unparse_upper)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "in, out");
    {
	SV *	in = ST(0)
;
	SV *	out = ST(1)
;
#line 523 "UUID.xs"
    do_unparse_upper(in, out);
#line 735 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_parse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_parse)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "in, out");
    {
	SV *	in = ST(0)
;
	SV *	out = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 531 "UUID.xs"
    RETVAL = do_parse(in, out);
#line 756 "UUID.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_UUID_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
#line 540 "UUID.xs"
    do_clear(in);
#line 775 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_is_null); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_is_null)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 547 "UUID.xs"
    RETVAL = do_is_null(in);
#line 794 "UUID.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_UUID_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dst, src");
    {
	SV *	dst = ST(0)
;
	SV *	src = ST(1)
;
#line 556 "UUID.xs"
    do_copy(dst, src);
#line 815 "UUID.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_UUID_compare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_compare)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "uu1, uu2");
    {
	SV *	uu1 = ST(0)
;
	SV *	uu2 = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 563 "UUID.xs"
    RETVAL = do_compare(uu1, uu2);
#line 836 "UUID.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_UUID_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_uuid)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 571 "UUID.xs"
    RETVAL = do_uuid();
#line 854 "UUID.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_UUID_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_UUID_debug)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 579 "UUID.xs"
    do_debug();
#line 871 "UUID.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_UUID); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_UUID)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("UUID::generate", XS_UUID_generate, file, "$");
        (void)newXSproto_portable("UUID::generate_random", XS_UUID_generate_random, file, "$");
        (void)newXSproto_portable("UUID::generate_time", XS_UUID_generate_time, file, "$");
        (void)newXSproto_portable("UUID::unparse", XS_UUID_unparse, file, "$$");
        (void)newXSproto_portable("UUID::unparse_lower", XS_UUID_unparse_lower, file, "$$");
        (void)newXSproto_portable("UUID::unparse_upper", XS_UUID_unparse_upper, file, "$$");
        (void)newXSproto_portable("UUID::parse", XS_UUID_parse, file, "$$");
        (void)newXSproto_portable("UUID::clear", XS_UUID_clear, file, "$");
        (void)newXSproto_portable("UUID::is_null", XS_UUID_is_null, file, "$");
        newXS_deffile("UUID::copy", XS_UUID_copy);
        newXS_deffile("UUID::compare", XS_UUID_compare);
        (void)newXSproto_portable("UUID::uuid", XS_UUID_uuid, file, "");
        (void)newXSproto_portable("UUID::debug", XS_UUID_debug, file, "");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

